// (c)Hundredsoft Corporation. 2012 All right reserved.
//	NAME
//		hsPaint.js
//
//	FUNCTION
//		Pict
//
//	REVISION
//		1.00	T.Furuhon	May-20-2012	Original
//
//	UTF-8で保存して下さい
//
////////////////////////////////////////////////////////////

new function() {

///////////////////////////////////
// Private Scope
///////////////////////////////////
var m_color = "#000000";
var m_size = 1;
var m_hexnum = [];
var m_palleth = new Image();
var m_palletv = new Image();
var m_palletp = [];
var m_ctx = null;
var m_width = 380;
var m_height = 690;
var m_kind = 0; // 0:free, 1:line, 2:circle, 3:allow, 4:ABC(ON/OFF),
				// 5:undo, 6:redo, 7:delete,
				// 8:delmark(fix-Polygon), 9:fix-Polygon, 10:ABC(Disp)
var m_imgdata = null;
var m_state = 0;
var m_layout = false;
var m_keydiv = null;

// ツール描画
//
var draw = function (){
	if (m_state != 0){
		if (m_layout == "left"){
			m_ctx.clearRect(60, 0, m_width, m_height);
			m_ctx.putImageData(m_imgdata, 60, 0);
		}else if (m_layout == "top"){
			m_ctx.clearRect(0, 60, m_width, m_height);
			m_ctx.putImageData(m_imgdata, 0, 60);
		}else if (m_layout == "right"){
			m_ctx.clearRect(0, 0, m_width-60, m_height);
			m_ctx.putImageData(m_imgdata, 0, 0);
		}else if (m_layout == "bottom"){
			m_ctx.clearRect(0, 0, m_width, m_height-60);
			m_ctx.putImageData(m_imgdata, 0, 0);
		}else{
			m_ctx.clearRect(0, 0, m_width, m_height);
			m_ctx.putImageData(m_imgdata, 0, 0);
		}
		hsPaintToolPublic.draw();
	}
};

// コントロールパネル描画
//
var update = function (){
	if (m_state == 0){
		return;
	}
	if (!m_layout){
		return;
	}

	var posleft=0,postop=0;
	if (m_layout == "left"){
		m_ctx.clearRect(0, 0, 60, m_height);
		posleft=0; postop=0;
	}else if (m_layout == "top"){
		m_ctx.clearRect(0, 0, m_width, 60);
		posleft=0; postop=0;
	}else if (m_layout == "bottom"){
		m_ctx.clearRect(0, m_height-60, m_width, 60);
		posleft=0; postop=(m_height-60);
	}else if (m_layout == "right"){
		m_ctx.clearRect(m_width-60, 0, 60, m_height);
		posleft=(m_width-60); postop=0;
	}

	m_ctx.lineWidth = 1;
	m_ctx.strokeStyle = "#000000";
	m_ctx.fillStyle = "#FFFFFF";
	m_ctx.beginPath();
	if (m_layout == "left" || m_layout == "right"){
		m_ctx.rect(posleft, postop, 60, m_height);
	}else{
		m_ctx.rect(posleft, postop, m_width, 60);
	}
	m_ctx.fill();
	m_ctx.closePath();

	if (m_layout == "left" || m_layout == "right"){
		m_ctx.drawImage(m_palletv, posleft, postop, 60, 690);
		if (hsPaintToolPublic.enableUndo()){
			m_ctx.putImageData(m_palletp[2], posleft, 276);
		}
		if (hsPaintToolPublic.enableRedo()){
			m_ctx.putImageData(m_palletp[3], posleft, 276+45);
		}
	}else if (m_layout == "top" || m_layout == "bottom"){
		m_ctx.drawImage(m_palleth, posleft, postop, 690, 60);
		if (hsPaintToolPublic.enableUndo()){
			m_ctx.putImageData(m_palletp[0], 276, postop);
		}
		if (hsPaintToolPublic.enableRedo()){
			m_ctx.putImageData(m_palletp[1], 276+45, postop);
		}
	}

	m_ctx.beginPath();
	if (m_layout == "left" || m_layout == "right"){
		m_ctx.rect(posleft+2, postop+2, 28, 44);
	}else if (m_layout == "top" || m_layout == "bottom"){
		m_ctx.rect(posleft+2, postop+2, 44, 28);
	}
	m_ctx.fill();
	m_ctx.closePath();

	m_ctx.fillStyle = "#000000";
	m_ctx.beginPath();
	if (m_layout == "left" || m_layout == "right"){
		m_ctx.rect(posleft+30, postop+2, 28, 44);
	}else{
		m_ctx.rect(posleft+25, postop+2, 23, 55);
	}
	m_ctx.fill();
	m_ctx.closePath();

	m_ctx.beginPath();
	var sz = hsPaintToolPublic.getlinewidth(m_size);
	m_ctx.lineWidth = sz*2;
	m_ctx.strokeStyle = m_color;
	m_ctx.fillStyle = m_color;

	if (m_layout == "left" || m_layout == "right"){
		if (m_kind == 0){
			m_ctx.arc(posleft+9, postop+23+7, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.arc(posleft+9+43, postop+23-15, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.moveTo(posleft+9, postop+23+7);
			m_ctx.quadraticCurveTo(posleft+9+7, postop+23-13, posleft+9+16, postop+23);
			m_ctx.quadraticCurveTo(posleft+9+28, postop+23+37, posleft+9+43, postop+23-15);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 1){
			m_ctx.arc(posleft+9, postop+23-15, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.arc(posleft+52, postop+23+15, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.moveTo(posleft+9, postop+23-15);
			m_ctx.lineTo(posleft+52, postop+23+15);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 2){
			var xs = posleft+9;
			var ys = postop+23-15;
			var xe = posleft+52;
			var ye = postop+23+15;
			var ry = (ye + ys) / 2;
			var hd = Math.abs(ye - ys) * 7 / 10;
			var x1 = Math.min(xe, xs);
			var y1 = ry - hd;
			var x2 = Math.max(xe, xs);
			var y2 = ry + hd;
			m_ctx.beginPath();
			m_ctx.moveTo(x1, ry);
			m_ctx.bezierCurveTo(x1, y1, x2, y1, x2, ry);
			m_ctx.bezierCurveTo(x2, y2, x1, y2, x1, ry);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 3){
			var xs = posleft+9;
			var ys = postop+23;
			var xe = posleft+52;
			var ye = postop+23;
			m_ctx.lineWidth = 1;
			hsPaintToolPublic.paintallow(xs-5, ys-10, xe+5, ye-10, sz);
			hsPaintToolPublic.paintallow(xe+5, ys+10, xs-5, ye+10, sz);

		}else if (m_kind == 4){
			m_ctx.font = "bold 16px 'MS Gothic'";
			m_ctx.fillText(" ", posleft+9, postop+23+8);
			m_ctx.fillText("A B C", posleft+9, postop+23+8);

		}else if (m_kind == 7){
			m_ctx.font = "bold 16px 'MS Gothic'";
			m_ctx.fillStyle = "#00FF00";
			m_ctx.fillText(" ", posleft+9-4, postop+23+8);
			m_ctx.fillText("Delete", posleft+9-4, postop+23+8);
		}

	}else{
		if (m_kind == 0){
			m_ctx.arc(posleft+8, postop+29+10, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.arc(posleft+8+35, postop+29-20, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.moveTo(posleft+8, postop+29+10);
			m_ctx.quadraticCurveTo(posleft+8+7, postop+29-13, posleft+8+14, postop+29);
			m_ctx.quadraticCurveTo(posleft+8+25, postop+29+50, posleft+8+35, postop+29-20);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 1){
			m_ctx.arc(posleft+8, postop+29-18, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.arc(posleft+43, postop+29+18, sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			m_ctx.beginPath();
			m_ctx.moveTo(posleft+8, postop+29-18);
			m_ctx.lineTo(posleft+43, postop+29+18);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 2){
			var xs = posleft+8;
			var ys = postop+29-18;
			var xe = posleft+43;
			var ye = postop+29+18;
			var ry = (ye + ys) / 2;
			var hd = Math.abs(ye - ys) * 7 / 10;
			var x1 = Math.min(xe, xs);
			var y1 = ry - hd;
			var x2 = Math.max(xe, xs);
			var y2 = ry + hd;
			m_ctx.beginPath();
			m_ctx.moveTo(x1, ry);
			m_ctx.bezierCurveTo(x1, y1, x2, y1, x2, ry);
			m_ctx.bezierCurveTo(x2, y2, x1, y2, x1, ry);
			m_ctx.stroke();
			m_ctx.closePath();

		}else if (m_kind == 3){
			var xs = posleft+8;
			var ys = postop+29;
			var xe = posleft+43;
			var ye = postop+29;
			m_ctx.lineWidth = 1;
			hsPaintToolPublic.paintallow(xs-5, ys-12, xe+5, ye-12, sz);
			hsPaintToolPublic.paintallow(xe+5, ys+12, xs-5, ye+12, sz);

		}else if (m_kind == 4){
			m_ctx.font = "bold 16px 'MS Gothic'";
			m_ctx.fillText(" ", posleft+8+4, postop+29+8);
			m_ctx.fillText("ABC", posleft+8+4, postop+29+8);

		}else if (m_kind == 7){
			m_ctx.font = "bold 16px 'MS Gothic'";
			m_ctx.fillStyle = "#00FF00";
			m_ctx.fillText(" ", posleft+8+4, postop+29+8);
			m_ctx.fillText("DEL", posleft+8+4, postop+29+8);
		}
	}
};

// 背景画像取得
//
var getImage = function (){
	if (m_layout == "right"){
		m_imgdata = m_ctx.getImageData(0, 0, (m_width-60), m_height);
	}else if (m_layout == "left"){
		m_imgdata = m_ctx.getImageData(60, 0, (m_width-60), m_height);
	}else if (m_layout == "top"){
		m_imgdata = m_ctx.getImageData(0, 60, (m_width), m_height-60);
	}else if (m_layout == "bottom"){
		m_imgdata = m_ctx.getImageData(0, 0, (m_width), m_height-60);
	}else{
		m_imgdata = m_ctx.getImageData(0, 0, (m_width), m_height);
	}
};

///////////////////////////////////
// Public Scope
///////////////////////////////////
hsPaintPublic = {

init: function(ctx, w, h, keydiv, palletfilev, palletfileh, palletfilep, callback){
	var hexnum = new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");
	m_ctx = ctx;
	m_ctx.lineWidth = 1;
	m_ctx.font = "16px 'MS Gothic'";

	m_width = w;
	m_height = h;
	m_keydiv = keydiv;

	var count = 0;
	for (var i=0; i<16; i++){
		for (var j=0; j<16; j++){
			m_hexnum[count] = hexnum[i] + hexnum[j];
			count++;
		}
	}

	hsPaintToolPublic.init(m_ctx, 60, 0);

	if (palletfilev && palletfileh && palletfilep){
		m_palletv.src = palletfilev;
		m_palletv.onload = (function(){
			m_palleth.src = palletfileh;
			m_palleth.onload = (function(){
				var img = new Image();
				img.src = palletfilep;
				img.onload = (function(){
					var tcvs = document.createElement("canvas");
					tcvs.width  = 160;
					tcvs.height = 100;
					var tctx = tcvs.getContext("2d");
					tctx.drawImage(img, 0, 0);
					var timd;
					timd = tctx.getImageData(0, 0, 45, 60);
					m_palletp.push(timd); // Horizontal, undo
					timd = tctx.getImageData(45, 0, 45, 60);
					m_palletp.push(timd); // Horizontal, redo
					timd = tctx.getImageData(100, 0, 60, 45);
					m_palletp.push(timd); // Virtical, undo
					timd = tctx.getImageData(100, 45, 60, 45);
					m_palletp.push(timd); // Virtical, redo
					hsPaintPublic.clear();
					m_state = 1;
					if (callback){
						callback();
					}
					img.onload = false; // disable
				});
				m_palleth.onload = false; // disable
			});
			m_palletv.onload = false; // disable
		});

	}else{
		hsPaintPublic.clear();
		m_state = 1;
		m_layout = false;
		if (callback){
			callback();
		}
	}
},

// クリア 背景画像なし
//
clear: function (){
	m_ctx.clearRect(0, 0, m_width, m_height);
	m_size = 1;
	m_kind = 0;
	m_color = "#00FF00";
	getImage();
	hsPaintToolPublic.clear();
	update();
},

// クリア 背景画像あり
//
clear2: function (img, w, h){
	m_width = w;
	m_height = h;
	{
		// context.measureText不具合対策
		var str = "abc";
		var tw = m_ctx.measureText(str).width;
		m_ctx.font = "bold 16px 'MS Gothic'";
		m_ctx.fillStyle = m_color;
		m_ctx.fillText(str, 100, 100);
	}
	m_ctx.clearRect(0, 0, m_width, m_height);
	m_size = 1;
	m_kind = 0;
	m_color = "#00FF00";
	if (m_layout == "left"){
		m_ctx.drawImage(img, 60, 0);
	}else if (m_layout == "top"){
		m_ctx.drawImage(img, 0, 60);
	}else{
		m_ctx.drawImage(img, 0, 0);
	}
	getImage();
	hsPaintToolPublic.clear();
	update();
	m_state = 2;
},

// クリア 標準ツール削除
//
cleartool: function (){
	m_size = 1;
	m_kind = 0;
	m_color = "#00FF00";
	hsPaintToolPublic.deletealltool();
	draw();
	update();
},

// touchstart/mousedown
//
mdown: function (x, y){
	var posleft=0,postop=0;
	if (m_layout == "left"){
		posleft=0; postop=0;
	}else if (m_layout == "top"){
		posleft=0; postop=0;
	}else if (m_layout == "bottom"){
		posleft=0; postop=(m_height-60);
	}else if (m_layout == "right"){
		posleft=(m_width-60); postop=0;
	}

	if ((x >= posleft && m_layout == "right") 
	 || (x < posleft+60 && m_layout == "left") ){
		if (51 <= y && y < 411){ // Choice tool.
			var k = ((y-51) / 45) | 0;
			if (k == 5){ // Undo
				hsPaintToolPublic.undo();
				draw();
			}else if (k == 6){ // Redo
				hsPaintToolPublic.redo();
			}else{
				if (m_kind != k){
					m_kind = k;
					if (k == 4 && m_keydiv){
						var dom = m_keydiv.style;
						dom.visibility = "visible";
						dom.backgroundColor = "#808080";
					}else if (k != 4 && m_keydiv){
						var dom = m_keydiv.style;
						dom.visibility = "hidden";
					}
				}
			}
			update();

		}else if (2 <= y && y < 46){
			m_size++;
			update();

		}else if (y >= 418){ // Choice Color
			var pixel = m_ctx.getImageData(posleft, 418, 60, m_height-418);
			var pos = (x-(posleft) + (y-418) * 60) * 4;
			m_color = "#" + m_hexnum[ pixel.data[pos] ] + m_hexnum[ pixel.data[pos+1] ] + m_hexnum[ pixel.data[pos+2] ];
			update();
		}

	}else if ((y >= postop && m_layout == "bottom") 
	 || (y < postop+60 && m_layout == "top") ){
		if (51 <= x && x < 411){ // Choice tool.
			var k = ((x-51) / 45) | 0;
			if (k == 5){ // Do Undo
				hsPaintToolPublic.undo();
				draw();
			}else if (k == 6){ // Redo
				hsPaintToolPublic.redo();
				draw();
			}else{
				m_kind = k;
			}
			update();

		}else if (2 <= x && x < 46){
			m_size++;
			update();

		}else if (x >= 418){ // Choice Color
			var pixel = m_ctx.getImageData(418, postop, m_width-418, 60);
			var pos = (x-418 + (y-postop) * (m_width-418)) * 4;
			m_color = "#" + m_hexnum[ pixel.data[pos] ] + m_hexnum[ pixel.data[pos+1] ] + m_hexnum[ pixel.data[pos+2] ];
			update();
		}

	}else if (m_kind < 5){
		var i = hsPaintToolPublic.hittest(x, y);
		if (i >= 0){
			hsPaintToolPublic.edittool(i, x, y, m_kind, m_color, m_size);
		}else if (m_kind < 4){
			hsPaintToolPublic.createtool(m_kind, m_color, m_size, null, x, y);
		}
		if (m_kind == 0){
			hsPaintToolPublic.drawlastone();
		}else{
			draw();
		}

	}else if (m_kind == 7){ // Delete
		var i = hsPaintToolPublic.hittest(x, y);
		if (i >= 0){
			hsPaintToolPublic.deletetool(i);
		}
		draw();
		update();
	}
},

// touchmove/mousemove
//
mmove: function (x, y){
	if ((x < (m_width-60) && m_layout == "right")
	 || (x >= (60) && m_layout == "left")
	 || (y >= (60) && m_layout == "top")
	 || (y < (m_height-60) && m_layout == "bottom")
	){
		var k = hsPaintToolPublic.mmove(x, y);
		if (k == 0){
			hsPaintToolPublic.drawlastone();
		}else if (k > 0){
			draw();
		}
	}
},

// floating touch/rollover
//
mover: function (x, y){
//	if ((x < (m_width-60) && m_layout == "right")
//	 || (x >= (60) && m_layout == "left")
//	 || (y >= (60) && m_layout == "top")
//	 || (y < (m_height-60) && m_layout == "bottom")
//	){
//		draw();
//		hsPaintToolPublic.mover(x, y);
//	}
},

// touchend/mouseup
//
mup: function (x, y){
	if ((x < (m_width-60) && m_layout == "right")
	 || (x >= (60) && m_layout == "left")
	 || (y >= (60) && m_layout == "top")
	 || (y < (m_height-60) && m_layout == "bottom")
	){
		hsPaintToolPublic.mup(x, y);
	}
	draw();
	update();
},

// 文字列表示
//
strout: function (str){
	hsPaintToolPublic.strout(str, m_color);
	draw();
},

// 初期化状態確認用(debug)
//
getstate: function (){
	return m_state;
},

// 現在のコントロールパネル位置
//
getlayout: function (){
	return m_layout;
},

// コントロールパネル位置変更
//
setlayout: function (layout, w, h){
	m_layout = layout;
	m_width = w;
	m_height = h;
	update();
	if (m_layout == "left"){
		hsPaintToolPublic.setoffset(60, 0);
	}else if (m_layout == "top"){
		hsPaintToolPublic.setoffset(0, 60);
	}else{
		hsPaintToolPublic.setoffset(0, 0);
	}
},

// 強制再描画
//
redraw: function(){
	draw();
	update();
},

// 固定ツール追加（return: 識別子）
//
addpolygon: function(x, y, color, opt, opp, opc){
	return hsPaintToolPublic.createfixtool(9, color, 0, false, x, y, opt, opp, opc);
},

// 固定ツール変更
//
changepolygon: function(uid, x, y, color, opt, opp, opc){
	hsPaintToolPublic.modifyfixtool(uid, x, y, color, opt, opp, opc);
},

// 固定ツール削除
//
deletepolygon: function(uid){
	hsPaintToolPublic.deletefixtool(uid);
},

// 現在の描画色
//
getcolor: function (){
	return m_color;
},

// 描画色強制変更
//
setcolor: function (color){
	m_color = color;;
	update();
}

} // Public Scope

}; // Constructor

