// (c)Hundredsoft Corporation. 2012 All right reserved.
//	NAME
//		hsPaintEx.js
//
//	FUNCTION
//		Pict
//
//	REVISION
//		1.00	T.Furuhon	May-20-2012	Original
//
//	UTF-8で保存して下さい
//
////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////
//
// namespace hsPaintExPublic
//
//////////////////////////////////////////////////////
new function() {
var m_mouseoff = true;

hsPaintExPublic = {
init: function (canvasname, keyname, filename, layout, callback){
	var canvas = document.getElementById(canvasname);
	var keydiv = document.getElementById(keyname);
	var ctx = canvas.getContext('2d');
	var imgidx = 0;
	var mouseDown = false;
	var mouseX = 0;
	var mouseY = 0;

	if (!m_mouseoff){
		if (navigator.userAgent.indexOf('iPhone')>0 ||
			navigator.userAgent.indexOf('iPod')>0 || 
			navigator.userAgent.indexOf('iPad')>0 ||
			navigator.userAgent.indexOf('Android')>0) {

			canvas.addEventListener('touchstart',
				function(e) {
					e.preventDefault();
					var n = e.touches.length;
					if (n > 0) {
						mouseDown = true;
						var rect=e.target.getBoundingClientRect();
						mouseX = e.touches[n-1].pageX-rect.left;
						mouseY = e.touches[n-1].pageY-rect.top;
						hsPaintPublic.mdown(mouseX, mouseY);
					}
				}, false);
			canvas.addEventListener('touchend',
				function(e) {
					hsPaintPublic.mup(mouseX, mouseY);
					mouseDown = false;
				}, false);
			canvas.addEventListener('touchmove',
				function (e) {
					e.preventDefault();
					var rect=e.target.getBoundingClientRect();
					if (mouseDown) {
						var n = e.touches.length;
						for (var i=0; i<n; i++) {
							mouseX = e.touches[i].pageX-rect.left;
							mouseY = e.touches[i].pageY-rect.top;
							hsPaintPublic.mmove(mouseX, mouseY);
						}
					}else{
						var n = e.touches.length;
						if (n > 0){
							mouseX = e.touches[n-1].pageX-rect.left;
							mouseY = e.touches[n-1].pageY-rect.top;
							hsPaintPublic.mover(mouseX, mouseY);
						}
					}
				}, false
			);

		}else{
			canvas.addEventListener('mousedown',
				function(e) {
					e.preventDefault();
					mouseDown = true;
					var rect=e.target.getBoundingClientRect();
					mouseX = e.clientX-rect.left;
					mouseY = e.clientY-rect.top;
					hsPaintPublic.mdown(mouseX, mouseY);
				}, false);
			canvas.addEventListener('mouseup',
				function(e) {
					hsPaintPublic.mup(mouseX, mouseY);
					mouseDown = false;
				}, false);
			canvas.addEventListener('mousemove',
				function (e) {
					e.preventDefault();
					var rect=e.target.getBoundingClientRect();
					mouseX = e.clientX-rect.left;
					mouseY = e.clientY-rect.top;
					if (mouseDown) {
						hsPaintPublic.mmove(mouseX, mouseY);
					}else{
						hsPaintPublic.mover(mouseX, mouseY);
					}
				}, false
			);
		}
		hsPaintPublic.init(ctx, canvas.width, canvas.height, keydiv,
							"controlv.jpg","controlh.jpg","controlp.jpg",
							hsPaintExPublic.fileload(canvasname, filename, layout, callback));

	}else{
		hsPaintPublic.init(ctx, canvas.width, canvas.height, keydiv,
							false, false, false,
							hsPaintExPublic.fileload(canvasname, filename, layout, callback));
	}
},

fileload: function (canvasname, filename, layout, callback){
	return function(){
		var canvas = document.getElementById(canvasname);
		if (layout == "left" || layout == "right" || layout == "top" || layout == "bottom"){
			hsPaintPublic.setlayout(layout, canvas.width, canvas.height);
		}
		if (filename){
			var img = new Image();
			img.src = filename;
			img.onload = (function(){
				var lo = hsPaintPublic.getlayout();
				if (lo == "left" || lo == "right"){
					if (img.width > 320){
						canvas.width = img.width + 60;
					}else{
						canvas.width = 380;
					}
					if (img.height > 690){
						canvas.height = img.height;
					}else{
						canvas.height = 690;
					}
				}else if (lo == "top" || lo == "bottom"){
					if (img.width > 690){
						canvas.width = img.width;
					}else{
						canvas.width = 690;
					}
					if (img.height > 320){
						canvas.height = img.height + 60;
					}else{
						canvas.height = 380;
					}
				}
				hsPaintPublic.clear2(img, canvas.width, canvas.height);
				if (callback){
					callback();
				}
				img.onload = false; // disable
			});
		}
	}
}

} // Public Scope
}; // Constructor

