// (c)Hundredsoft Corporation. 2012 All right reserved.
//	NAME
//		hsPaintTool.js
//
//	FUNCTION
//		Pict
//
//		kind	0:free, 1:line, 2:circle, 3:allow, 4:ABC(ON/OFF),
//				5:undo, 6:redo, 7:delete,
//				8:delmark(fix-Polygon), 9:fix-Polygon, 10:ABC(Disp)
//
//	REVISION
//		1.00	T.Furuhon	May-20-2012	Original
//
//	UTF-8で保存して下さい
//
////////////////////////////////////////////////////////////

new function() {

///////////////////////////////////
 // Private Scope
///////////////////////////////////
var m_ctx = null;
var m_keyx = 100;
var m_keyy = 100;
var m_seqbuf = [[]];
var m_curr = 0;
var m_cnt = 0;
var m_offsetleft = 0;
var m_offsettop = 0;
var m_sizetbl = new Array(1, 1.5, 2.5, 4);

// 全てのツール継承元クラス
//
var basetool = function(kind, color, sz, str, rev, uns) {
	this.id = m_cnt++;
	this.kind = kind;
	this.color = color;
	this.sz = sz;
	this.str = str;
	this.rev = rev;
	this.uns = uns;
	this.x = [];
	this.y = [];
	this.opt = [];
	this.opp = [];
	this.opc = [];
	this.hittest = function(x,y){
		var n = this.x.length;
		if (n > 0){
			var dx = this.x[0] - x;
			var dy = this.y[0] - y;
			var d = dx*dx + dy*dy;
			if (d < 900){
				return 0;
			}
			dx = this.x[n-1] - x;
			dy = this.y[n-1] - y;
			d = dx*dx + dy*dy;
			if (d < 900){
				return n-1;
			}
		}
		return -1;
	};
};

// コピーコンストラクタ
//
var copytool = function(from) {
	var to = new basetool(0,0,0,null,false,false);
//	to.id = from.id;
	to.kind = from.kind;
	to.color = from.color;
	to.sz = from.sz;
	to.str = from.str;
	to.rev = from.rev;
	to.uns = from.uns;
	to.x = from.x.slice(0);
	to.y = from.y.slice(0);
	if (from.opt.length > 0){
		to.opt = from.opt.slice(0);
	}
	if (from.opp.length > 0){
		to.opp = from.opp.slice(0);
	}
	if (from.opc.length > 0){
		to.opc = from.opc.slice(0);
	}
	return to;
};

// 位置合わせ(Origin座標<->表示座標)
//
var orgx = function(x) {
	return x - m_offsetleft;
};

var orgy = function(y) {
	return y - m_offsettop;
};

var dispx = function(x) {
	return x + m_offsetleft;
};

var dispy = function(y) {
	return y + m_offsettop;
};

// 描画
//
var drawlastparts = function (tool){
	if (tool.kind == 0){ // free
		m_ctx.fillStyle = tool.color;
		var n = m_sizetbl.length;
		var sz = m_sizetbl[tool.sz % n];

		n = tool.x.length;
		if (n > 0){
			m_ctx.beginPath();
			m_ctx.arc(dispx(tool.x[n-1]), dispy(tool.y[n-1]), sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();

			if (n > 1){
				m_ctx.lineWidth = sz*2;
				m_ctx.strokeStyle = tool.color;
				m_ctx.beginPath();
				m_ctx.moveTo(dispx(tool.x[n-2]), dispy(tool.y[n-2]));
				m_ctx.lineTo(dispx(tool.x[n-1]), dispy(tool.y[n-1]));
				m_ctx.stroke();
				m_ctx.closePath();
			}
		}

	}else{
		drawparts(tool);
	}
};

var drawparts = function (tool){
	m_ctx.fillStyle = tool.color;
	var n = m_sizetbl.length;
	var sz = m_sizetbl[tool.sz % n];

	n = tool.x.length;
	if (n > 0){
		if (tool.kind < 2){ // free or line
			m_ctx.beginPath();
			m_ctx.arc(dispx(tool.x[0]), dispy(tool.y[0]), sz, 0, Math.PI*2, false);
			m_ctx.fill();
			m_ctx.closePath();
			for (var i=1; i<n; i++){
				m_ctx.beginPath();
				m_ctx.arc(dispx(tool.x[i]), dispy(tool.y[i]), sz, 0, Math.PI*2, false);
				m_ctx.fill();
				m_ctx.closePath();

				m_ctx.lineWidth = sz*2;
				m_ctx.strokeStyle = tool.color;
				m_ctx.beginPath();
				m_ctx.moveTo(dispx(tool.x[i-1]), dispy(tool.y[i-1]));
				m_ctx.lineTo(dispx(tool.x[i]), dispy(tool.y[i]));
				m_ctx.stroke();
				m_ctx.closePath();
			}

		}else if (tool.kind == 2){ // ellipse
			if (n > 1){
				var xs = dispx(tool.x[0]);
				var ys = dispy(tool.y[0]);
				var xe = dispx(tool.x[1]);
				var ye = dispy(tool.y[1]);
				var ry = (ye + ys) / 2;
				var hd = Math.abs(ye - ys) * 7 / 10;
				var x1 = Math.min(xe, xs);
				var y1 = ry - hd;
				var x2 = Math.max(xe, xs);
				var y2 = ry + hd;
				m_ctx.lineWidth = sz*2;
				m_ctx.strokeStyle = tool.color;
				m_ctx.beginPath();
				m_ctx.moveTo(x1, ry);
				m_ctx.bezierCurveTo(x1, y1, x2, y1, x2, ry);
				m_ctx.bezierCurveTo(x2, y2, x1, y2, x1, ry);
				m_ctx.stroke();
				m_ctx.closePath();
			}

		}else if (tool.kind == 3){ // Allow
			var x0,x1,y0,y1;
			if (tool.rev){
				x0 = dispx(tool.x[1]);
				y0 = dispy(tool.y[1]);
			}else{
				x0 = dispx(tool.x[0]);
				y0 = dispy(tool.y[0]);
			}
			x1 = x0;
			y1 = y0;
			if (n > 1){
				if (tool.rev){
					x1 = dispx(tool.x[0]);
					y1 = dispy(tool.y[0]);
				}else{
					x1 = dispx(tool.x[1]);
					y1 = dispy(tool.y[1]);
				}
			}
			m_ctx.fillStyle = tool.color;
			drawallow(x0, y0, x1, y1, sz);

		}else if (tool.kind == 9){ // polygon
			if (n > 2){
				var x0 = dispx(tool.x[0]);
				var y0 = dispy(tool.y[0]);
				var x,y;
				m_ctx.beginPath();
				if (tool.opp.length > 1){
					var xmin=x0,xmax=x0,ymin=y0,ymax=y0;
					for (var i=1; i<n; i++){
						x = dispx(tool.x[i]);
						y = dispy(tool.y[i]);
						if (xmin > x){
							xmin = x;
						}
						if (xmax < x){
							xmax = x;
						}
						if (ymin > y){
							ymin = y;
						}
						if (ymax < y){
							ymax = y;
						}
					}
					var grad;
					if (xmax == x0 && ymax == y0){
						grad = m_ctx.createLinearGradient(xmax, ymax, xmin, ymin);
					}else if (xmin == x0 && ymax == y0){
						grad = m_ctx.createLinearGradient(xmin, ymax, xmax, ymin);
					}else if (xmax == x0 && ymin == y0){
						grad = m_ctx.createLinearGradient(xmax, ymin, xmin, ymax);
					}else{
						grad = m_ctx.createLinearGradient(xmin, ymin, xmax, ymax);
					}
					for (var i=0; i<tool.opp.length; i++){
						grad.addColorStop(tool.opp[i],tool.opc[i]);
					}
					m_ctx.fillStyle = grad;

				}else{
					m_ctx.fillStyle = tool.color;
				}

				x = x0;
				y = y0;
				m_ctx.moveTo(x, y);

				for (var i=1; i<n; i++){
					if (tool.x[i] && tool.y[i]){
						if (tool.opt[i] == 1){
							x = dispx(tool.x[i]);
							y = dispy(tool.y[i]);
							var x1 = dispx(tool.x[i+1]);
							var y1 = dispy(tool.y[i+1]);
							m_ctx.quadraticCurveTo(x, y, x1, y1);
							i+=1;
						}else if (tool.opt[i] == 2){
							x = dispx(tool.x[i]);
							y = dispy(tool.y[i]);
							var x1 = dispx(tool.x[i+1]);
							var y1 = dispy(tool.y[i+1]);
							var x2 = dispx(tool.x[i+2]);
							var y2 = dispy(tool.y[i+2]);
							m_ctx.bezierCurveTo(x, y, x1, y1, x2, y2);
							i+=2;
						}else{
							x = dispx(tool.x[i]);
							y = dispy(tool.y[i]);
							m_ctx.lineTo(x, y);
						}
					}else{
						break;
					}
				}
				m_ctx.fill();
				m_ctx.closePath();
			}

		}else if (tool.kind == 10){
			m_ctx.font = "bold 16px 'MS Gothic'";
			m_ctx.fillStyle = tool.color;
			m_ctx.fillText(tool.str, dispx(tool.x[0]), dispy(tool.y[0]));
		}
	}

//debug
//	var mdev = document.getElementById('mouse_state');
//	var s = "";
//	for (var i=0; i<=m_curr; i++){
//		var n = m_seqbuf[i].length;
//		if (n > 0){
//			var m = m_seqbuf[i][n-1].x.length;
//			if (m > 0){
//				s += "[" + i + "]:" + m_seqbuf[i][n-1].x[m-1] + "," + m_seqbuf[i][n-1].y[m-1] + "<br />";
//			}
//		}
//	}
//	mdev.innerHTML = s;
};

// 矢印描画
//
var drawallow = function (x0, y0, x1, y1, sz){
	var dx,dy,ux,uy,px,py,qx,qy,vx,vy,len;
	dx = x1 - x0;
	dy = y1 - y0;
	len = dx*dx + dy*dy;
	if (len < 1){
		dx = 0;
		dy = 1;
		len = 1;
	}
	len = Math.sqrt(len);
	ux = dx / len;
	uy = dy / len;
	if (len < 10 + sz*4){
		x1 = x0 + ux * (10 + sz*4);
		y1 = y0 + uy * (10 + sz*4);
		dx = x1 - x0;
		dy = y1 - y0;
		len = 10 + sz*4;
	}
	vx = dy / len;
	vy = -dx / len;
	px = x0 + ux*10 + vx * 3.64; // 傘の開き加減
	py = y0 + uy*10 + vy * 3.64; // tan(20度)*10=3.64
	dx = px - x0;
	dy = py - y0;
	len = Math.sqrt(dx*dx + dy*dy);
	px = x0 + dx / len * (10 + sz*4);
	py = y0 + dy / len * (10 + sz*4);
	qx = x0 + ux*10 - vx * 3.64;
	qy = y0 + uy*10 - vy * 3.64;
	dx = qx - x0;
	dy = qy - y0;
	len = Math.sqrt(dx*dx + dy*dy);
	qx = x0 + dx / len * (10 + sz*4);
	qy = y0 + dy / len * (10 + sz*4);

	m_ctx.beginPath();
	m_ctx.moveTo(x0, y0);
	m_ctx.lineTo(px, py);
	m_ctx.lineTo((px+qx)/2 + vx*sz, (py+qy)/2 + vy*sz);
	m_ctx.lineTo(x1 + vx*sz, y1 + vy*sz);
	m_ctx.lineTo(x1 - vx*sz, y1 - vy*sz);
	m_ctx.lineTo((px+qx)/2 - vx*sz, (py+qy)/2 - vy*sz);
	m_ctx.lineTo(qx, qy);
	m_ctx.lineTo(x0, y0);
	m_ctx.fill();
	m_ctx.closePath();
};


///////////////////////////////////
// Public Scope
///////////////////////////////////
hsPaintToolPublic = {

init: function(ctx, left, top){
	m_ctx = ctx;
	m_offsetleft = left;
	m_offsettop = top;

	// Redo/Undo bufferClear
	m_seqbuf[0] = [];
},

// offset変更
//
setoffset: function(left, top) {
	m_offsetleft = left;
	m_offsettop = top;
},

// hittest - touchstartで呼ばれる
//
hittest: function(x, y) {
	x = orgx(x);
	y = orgy(y);
	for (var i=m_seqbuf[m_curr].length-1; i>=0; i--){
		if (!m_seqbuf[m_curr][i].uns){
			if (m_seqbuf[m_curr][i].hittest(x,y) >= 0){
				return i;
			}
		}
	}
	return -1;
},

// hitmark - ロールオーバーで呼ばれる
// マウスか、Sony Xperia sola - Floating tuchしかできない
//
hitmark: function(ix) {
	var n = m_seqbuf[m_curr][ix].x.length;
	if (n > 0){
		var x0 = dispx(m_seqbuf[m_curr][ix].x[0]);
		var y0 = dispy(m_seqbuf[m_curr][ix].y[0]);
		var x1 = dispx(m_seqbuf[m_curr][ix].x[n-1]);
		var y1 = dispy(m_seqbuf[m_curr][ix].y[n-1]);

		m_ctx.strokeStyle = "#FF0000";
		m_ctx.lineWidth = 2;
		m_ctx.beginPath();
		m_ctx.arc(x0, y0, 20, 0, Math.PI*2, false);
		m_ctx.stroke();
		m_ctx.closePath();

		m_ctx.beginPath();
		m_ctx.arc(x1, y1, 20, 0, Math.PI*2, false);
		m_ctx.stroke();
		m_ctx.closePath();

		m_ctx.strokeStyle = "#0000FF";
		m_ctx.beginPath();
		m_ctx.moveTo(x0-18, y0-18);
		m_ctx.lineTo(x0+18, y0+18);
		m_ctx.stroke();
		m_ctx.closePath();
		m_ctx.beginPath();
		m_ctx.moveTo(x0-18, y0+18);
		m_ctx.lineTo(x0+18, y0-18);
		m_ctx.stroke();
		m_ctx.closePath();

		m_ctx.beginPath();
		m_ctx.moveTo(x1-18, y1-18);
		m_ctx.lineTo(x1+18, y1+18);
		m_ctx.stroke();
		m_ctx.closePath();
		m_ctx.beginPath();
		m_ctx.moveTo(x1-18, y1+18);
		m_ctx.lineTo(x1+18, y1-18);
		m_ctx.stroke();
		m_ctx.closePath();
	}
},

// 標準ツール作成
//
createtool: function(kind, color, sz, str, x, y){
	var n = m_seqbuf.length;
	if (n-1 > m_curr){
		m_seqbuf.splice(m_curr+1, n-1 - m_curr);
	}

	var tools = [];
	n = m_seqbuf[m_curr].length;
	if (n > 0){
		for (var i=0; i<m_seqbuf[m_curr].length; i++){
			tools.push(m_seqbuf[m_curr][i]);
		}
	}
	m_seqbuf.push(tools);
	m_curr = m_seqbuf.length - 1;

	var tool = new basetool(kind, color, sz, str, false, false);
	tool.x[0] = orgx(x);
	tool.y[0] = orgy(y);
	m_seqbuf[m_curr].push(tool);
},

// 標準ツール編集
//
edittool: function(ix, x, y, kind, color, sz){
	var n = m_seqbuf[m_curr].length;
	if (ix >= n){
		return;
	}

	n = m_seqbuf.length;
	if (n-1 > m_curr){
		m_seqbuf.splice(m_curr+1, n-1 - m_curr);
	}

	var tools = [];
	n = m_seqbuf[m_curr].length;
	if (n > 0){
		for (var i=0; i<m_seqbuf[m_curr].length; i++){
			var tool = copytool(m_seqbuf[m_curr][i]);
			tools.push(tool);
		}
	}
	m_seqbuf.push(tools);
	m_curr = m_seqbuf.length - 1;

	var tool = m_seqbuf[m_curr][ix];
	if (color){
		tool.color = color;
	}
	if (sz){
		tool.sz = sz;
	}
	if (tool.hittest(orgx(x), orgy(y)) == 0){
		n = tool.x.length;
		var work_x = [];
		var work_y = [];
		for (var i=n-1; i>=0; i--){
			work_x.push(tool.x[i]);
			work_y.push(tool.y[i]);
		}
		tool.x = work_x;
		tool.y = work_y;
		if (tool.rev){
			tool.rev = false;
		}else{
			tool.rev = true;
		}
	}
	if (kind >= 0){
		if (tool.kind < 4 && kind < 4){
			if (tool.kind == 0 && kind != 0){
				n = tool.x.length;
				if (n > 2){
					tool.x[1] = tool.x[n-1];
					tool.y[1] = tool.y[n-1];
					tool.x.splice(2, n-2);
					tool.y.splice(2, n-2);
				}
			}
			tool.kind = kind;
		}
	}
	m_seqbuf[m_curr].splice(ix, 1);
	m_seqbuf[m_curr].push(tool);
},

// 標準ツール削除
//
deletetool: function(ix){
	var n = m_seqbuf[m_curr].length;
	if (ix >= n){
		return;
	}

	n = m_seqbuf.length;
	if (n-1 > m_curr){
		m_seqbuf.splice(m_curr+1, n-1 - m_curr);
	}

	var tools = [];
	n = m_seqbuf[m_curr].length;
	if (n > 0){
		for (var i=0; i<m_seqbuf[m_curr].length; i++){
			tools.push(m_seqbuf[m_curr][i]);
		}
	}
	m_seqbuf.push(tools);
	m_curr = m_seqbuf.length - 1;

	m_seqbuf[m_curr].splice(ix, 1);
},

// 標準ツール全削除
//
deletealltool: function(){
	m_curr = 0;
	var n = m_seqbuf.length;
	if (n > 1){
		m_seqbuf.splice(1, n-1);
	}
	m_keyx = 100;
	m_keyy = 100;
},

// 固定ツール作成(Polygonだけ)
// Undo-Redoに反応しないもの
//
createfixtool: function(kind, color, sz, str, x, y, opt, opp, opc){
	var n = m_seqbuf.length;
	if (n-1 > m_curr){
		m_seqbuf.splice(m_curr+1, n-1 - m_curr);
	}

	var tool = new basetool(kind, color, sz, str, false, true);
	for (var i=0; i<x.length; i++){
		tool.x.push(orgx(x[i]));
		tool.y.push(orgy(y[i]));
	}
	if (opt && opt.length > 0){
		tool.opt = opt.slice(0);
	}
	if (opp && opp.length > 0){
		tool.opp = opp.slice(0);
	}
	if (opc && opc.length > 0){
		tool.opc = opc.slice(0);
	}
	for (var i=0; i<m_seqbuf.length; i++){
		m_seqbuf[i].unshift(tool);
	}
	var n = 0;
	for (var i=0; i<m_seqbuf[0].length; i++){
		if (m_seqbuf[0][i].uns){
			n++;
		}
	}
	return n-1;
},

// 固定ツール変更
//
modifyfixtool: function(uid, x, y, color, opt, opp, opc){
	var i,j, n = 0;
	for (j=m_seqbuf[0].length-1; j>=0; j--){
		if (m_seqbuf[0][j].uns){
			n++;
			if (n > uid){
				break;
			}
		}
	}
	j = m_seqbuf[0].length - 1 - j;
	if (x && y){
		for (i=0; i<x.length; i++){
			x[i] = orgx(x[i]);
			y[i] = orgy(y[i]);
		}
		for (var i=0; i<m_seqbuf.length; i++){
			m_seqbuf[i][j].x = x;
			m_seqbuf[i][j].y = y;
			m_seqbuf[i][j].opt = opt;
			m_seqbuf[i][j].opp = opp;
			m_seqbuf[i][j].opc = opc;
		}
	}
	if (color){
		for (var i=0; i<m_seqbuf.length; i++){
			m_seqbuf[i][j].color = color;
		}
	}
},

// 固定ツール削除
// 実際には削除しない,削除マークを付ける
//
deletefixtool: function(uid){
	var i,j, n = 0;
	for (j=m_seqbuf[0].length-1; j>=0; j--){
		if (m_seqbuf[0][j].uns){
			n++;
			if (n > uid){
				break;
			}
		}
	}
	j = m_seqbuf[0].length - 1 - j;
	for (var i=0; i<m_seqbuf.length; i++){
		m_seqbuf[i][j].kind = 8; // delete mark
		m_seqbuf[i][j].x = [];
		m_seqbuf[i][j].y = [];
		m_seqbuf[i][j].opt = [];
		m_seqbuf[i][j].opp = [];
		m_seqbuf[i][j].opc = [];
	}
},

// ツール描画
//
draw: function (){
	for (var i=0; i<m_seqbuf[m_curr].length; i++){
		drawparts(m_seqbuf[m_curr][i]);
	}
},
drawlastone: function (){
	var n = m_seqbuf[m_curr].length;
	drawlastparts(m_seqbuf[m_curr][n-1]);
},

// クリア
//
clear: function (){
	m_keyx = 100;
	m_keyy = 100;

	var n = m_seqbuf.length;
	if (n > 0){
		m_seqbuf.splice(0, n);
	}
	m_seqbuf[0] = [];
	m_curr = 0;
},

// Undo/Redo
//
undo: function (){
	if (m_curr > 0){
		m_curr--;
	}
},
redo: function (){
	if (m_seqbuf.length - 1 > m_curr){
		m_curr++;
	}
},

// touchmove/mousemove
//
mmove: function (x, y){
	var n = m_seqbuf[m_curr].length;
	if (n > 0){
		var kind = m_seqbuf[m_curr][n-1].kind;
		if (kind < 4 || kind == 10){
			if (kind == 10){
				m_seqbuf[m_curr][n-1].x[0] = orgx(x);
				m_seqbuf[m_curr][n-1].y[0] = orgy(y);
			}else if (kind != 0){
				m_seqbuf[m_curr][n-1].x[1] = orgx(x);
				m_seqbuf[m_curr][n-1].y[1] = orgy(y);
			}else{
				m_seqbuf[m_curr][n-1].x.push(orgx(x));
				m_seqbuf[m_curr][n-1].y.push(orgy(y));
			}
		}
		return kind;
	}
	return -1;
},

// floating touch/rollover
//
mover: function (x, y){
	var n = m_seqbuf[m_curr].length;
	var i = this.hittest(x, y);
	if (i >= 0 && i < n){
		this.hitmark(i);
	}
},

// touchend/mouseup
//
mup: function (x, y){
	var n = m_seqbuf[m_curr].length;
	if (n > 0){
		var tool = m_seqbuf[m_curr][n-1];
		n = tool.x.length;
		if (n > 0){
			var dx = x - dispx(tool.x[0]);
			var dy = y - dispy(tool.y[0]);
			var len = (dx*dx + dy*dy);
			if (len < 1){
				dx = x + 2;
				dy = y + 18;
			}else{
				len = Math.sqrt(len);
				var ux = dx / len;
				var uy = dy / len;
				dx = x + ux*18;
				dy = y + uy*18;
				dx -= 10;
				dy += 8;
			}
			if(dy < 15){dy = 15;}
			m_keyx = dx;
			m_keyy = dy;
		}
	}
},

// 文字列表示
//
strout: function (str, color){
	var w = m_ctx.measureText(str).width;
	this.createtool(10, color, 0, str, m_keyx, m_keyy);
	m_keyx += w;
},

// 矢印描画
//
paintallow: function (x0, y0, x1, y1, sz){
	drawallow(x0, y0, x1, y1, sz);
},

// Undo/Redo可能？
//
enableUndo: function (){
	if (m_curr > 0){
		return true;
	}else{
		return false;
	}
},
enableRedo: function (){
	if (m_seqbuf.length - 1 > m_curr){
		return true;
	}else{
		return false;
	}
},

// 線幅計算
//
getlinewidth: function (sz){
	var n = m_sizetbl.length;
	return m_sizetbl[sz % n];
}


} // Public Scope

}; // Constructor

