// (c)Hundredsoft Corporation. 2012 All right reserved.
//	NAME
//		hsVacuumPaint.js
//
//	FUNCTION
//		VacuumPaint
//
//	REVISION
//		1.00	T.Furuhon	May-13-2012	Original
//
//	UTF-8で保存して下さい
//
////////////////////////////////////////////////////////////

new function() {

///////////////////////////////////
 // Private Scope
///////////////////////////////////
var m_points_x = [[]];
var m_points_y = [[]];
var m_ctx;
var m_cx = 180;
var m_cy = 180;
var m_r = 170;
var m_canvas_w;
var m_canvas_h;
var m_mincount = 10;
var m_bcolor = "rgba(255, 255, 255, 0.9)"; // inner color
var m_ncolor = "#808080";                  // intima color
var m_fcolor = "#000000";                  // media color
var m_idx = 2;  // 0:outer, 1:media, 2:intima
var m_ring_x = [];
var m_ring_y = [];
var m_sin = [];
var m_cos = [];

// 重力パラメタ
//
var calctbl = new Array(
	20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 
	20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 20.00, 
	20.00, 20.00, 20.30, 20.60, 21.00, 21.30, 21.60, 22.00, 22.50, 23.00, 
	23.50, 24.20, 25.00, 26.09, 27.67, 29.22, 30.74, 32.22, 33.66, 35.07, 
	36.45, 37.79, 39.11, 40.39, 41.65, 42.89, 44.10, 45.30, 46.47, 47.63, 
	48.77, 49.90, 51.01, 52.11, 53.21, 54.29, 55.36, 56.43, 57.49, 58.54, 
	59.59, 60.63, 61.67, 62.70, 63.74, 64.76, 65.79, 66.81, 67.83, 68.85, 
	69.86, 70.88, 71.89, 72.90, 73.91, 74.92, 75.93, 76.93, 77.94, 78.95, 
	79.95, 80.96, 81.96, 82.97, 83.97, 84.97, 85.97, 86.98, 87.98, 88.98, 
	89.98, 90.98, 91.99, 92.99, 93.99, 94.99, 95.99, 96.99, 97.99, 98.99, 
	99.99);

// 描画
//
var update = function (ctx, color){
	var i,x,y,idx;
	ctx.clearRect(0, 0, m_canvas_w, m_canvas_h);
	ctx.fillStyle = "#FFFFFF";
//	ctx.beginPath();
//	ctx.rect(0, 0, m_canvas_w, m_canvas_h);
//	ctx.fill();
//	ctx.closePath();

	if (!color){
		ctx.fillStyle = "#000000";
		if (m_idx == 1){
			ctx.fillText("Media Edit", 5, 15);
		}else if (m_idx == 2){
			ctx.fillText("Intima Edit", 5, 15);
		}else{
			ctx.fillText("Outer Edit", 5, 15);
		}
	}

	ctx.lineWidth = 1;
	ctx.strokeStyle = "#000000";

//	ctx.fillStyle = "#CDCDCD";
	ctx.fillStyle = "#FFFFFF";
	ctx.beginPath();
	ctx.moveTo(m_ring_x[0], m_ring_y[0]);
	for (i=0; i<m_ring_x.length; i++){
		ctx.lineTo(m_ring_x[i], m_ring_y[i]);
	}
	ctx.fill();
	ctx.closePath();

	for (idx=0; idx<3; idx++){
		var n = m_points_x[idx].length;

		if (n >= m_mincount){
			var points_x = m_points_x[idx];
			var points_y = m_points_y[idx];

			ctx.beginPath();
			if (idx == 0){
				ctx.fillStyle = "#000000";
			}else if (idx == 1){
				if (!color){
					ctx.fillStyle = m_ncolor;
				}else{
					ctx.fillStyle = color;
				}
			}else if (idx == 2){
				if (!color){
					ctx.fillStyle = m_bcolor;
				}else{
					ctx.fillStyle = "#FFFFFF";
				}
			}
			ctx.moveTo(points_x[0], points_y[0]);
//				ctx.lineTo(points_x[0], points_y[0]+1);
			for (i=1; i<n; i++){
//					ctx.moveTo(points_x[i], points_y[i]+1);
				ctx.lineTo(points_x[i], points_y[i]);
			}
//				ctx.moveTo(points_x[0], points_y[0]+1);
			ctx.lineTo(points_x[0], points_y[0]);
			ctx.fill();
//			ctx.stroke();
			ctx.closePath();

		}else{
			m_points_x[idx] = [];
			m_points_y[idx] = [];
		}
	}

	var n = m_points_x[0].length;
	if (n >= m_mincount){
		var points_x = m_points_x[0];
		var points_y = m_points_y[0];

		ctx.lineWidth = 3;
		ctx.strokeStyle = "#000000";
		ctx.beginPath();
		ctx.moveTo(points_x[0], points_y[0]);
		for (i=1; i<n; i++){
			ctx.lineTo(points_x[i], points_y[i]);
		}
		ctx.lineTo(points_x[0], points_y[0]);
		ctx.stroke();
		ctx.closePath();
	}

};

// 重力計算
//
var calc = function (x, y, r, idx){
	var i,j,k;
	var points_x = m_points_x[idx];
	var points_y = m_points_y[idx];
	var n = points_x.length;
	var dx, dy, lx, ly, ux, uy, len, w, qi;
	var work_x = [];
	var work_y = [];

	if (n < m_mincount){
		return;
	}

	dx = x - m_cx;
	dy = y - m_cy;
	len = Math.sqrt(dx*dx + dy*dy);
	if (len > r){
		x = m_cx + dx * r / len;
		y = m_cy + dy * r / len;
	}

	qi = 0;
	for (i=0; i<n; i++){
		dx = points_x[i] - x;
		dy = points_y[i] - y;
		len = Math.sqrt(dx*dx + dy*dy);
		if (len < 20){
			points_x[i] = x;
			points_y[i] = y;
			qi = i;
		}else if (len < 70){
			var ux = dx / len;
			var uy = dy / len;
			var p = calctbl[len | 0];
			points_x[i] = x + ux * p;
			points_y[i] = y + uy * p;
		}else{
			i += 1;
		}
	}

	lx = points_x[qi];
	ly = points_y[qi];
	work_x.push(lx);
	work_y.push(ly);
	n = points_x.length;
	for (i=1; i<n/2; i++){
		var qin = (qi+i) % n;
		var xq = points_x[qin];
		var yq = points_y[qin];
		dx = xq - lx;
		dy = yq - ly;
		len = (dx*dx + dy*dy);
		if (len < 4*4){
			continue;
		}
		if (len > 8*8){
			len = Math.sqrt(len);
			ux = 4 * dx / len;
			uy = 4 * dy / len;
			w = len | 0;
			for (j=4; j<w; j+=4){
				lx += ux;
				ly += uy;
				work_x.push(lx);
				work_y.push(ly);
			}
		}else{
			work_x.push(xq);
			work_y.push(yq);
			lx = xq;
			ly = yq;
		}
	}
	k = i;
	qi += n;

	lx = work_x[0];
	ly = work_y[0];
	for (i=0; i<n-k+1; i++){
		var qin = (qi-i) % n;
		var xq = points_x[qin];
		var yq = points_y[qin];
		dx = xq - lx;
		dy = yq - ly;
		len = (dx*dx + dy*dy);
		if (len < 4*4){
			continue;
		}
		if (len > 8*8){
			len = Math.sqrt(len);
			ux = 4 * dx / len;
			uy = 4 * dy / len;
			w = len | 0;
			for (j=4; j<w; j+=4){
				lx += ux;
				ly += uy;
				work_x.unshift(lx);
				work_y.unshift(ly);
			}
		}else{
			work_x.unshift(xq);
			work_y.unshift(yq);
			lx = xq;
			ly = yq;
		}
	}

	points_x = work_x;
	points_y = work_y;

	w  = r * r / 20;
	n = points_x.length;
	for (i=0; i<n; i++){
		var qin = (i+2) % n;
		dx = work_x[qin] - x;
		dy = work_y[qin] - y;
		len = (dx*dx + dy*dy);
		if (len < w)
		{
			dx = dy = 0;
			for (j=0; j<5; j++){
				dx += work_x[(i+j)%n];
				dy += work_y[(i+j)%n];
			}
			points_x[qin] = dx / 5;
			points_y[qin] = dy / 5;
		}
	}

	m_points_x[idx] = points_x;
	m_points_y[idx] = points_y;
};

// 重心計算
//
var getgravity = function(points_x, points_y, width, height){
	var i,j;
	var work_x=[], work_y=[];
	var lx = points_x[0];
	var ly = points_y[0];
	work_x.push(lx);
	work_y.push(ly);

	var n = points_x.length;
	for (i=1; i<n; i++){
		var dx = points_x[i] - lx;
		var dy = points_y[i] - ly;
		var len = (dx*dx + dy*dy);
		if (len < 4*4){
			continue;
		}
		if (len > 8*8){
			len = Math.sqrt(len);
			var ux = 4 * dx / len;
			var uy = 4 * dy / len;
			var w = len | 0;
			for (j=4; j<w; j+=4){
				lx += ux;
				ly += uy;
				work_x.push(lx);
				work_y.push(ly);
			}
		}else{
			work_x.push(points_x[i]);
			work_y.push(points_y[i]);
			lx = points_x[i];
			ly = points_y[i];
		}
	}

	lx = ly = 0;
	for (i=0; i<work_x.length; i++){
		lx += work_x[i];
		ly += work_y[i];
	}
	lx /= work_x.length;
	ly /= work_x.length;

	return {"x" : lx, "y" : ly};
};

// ring上の点Pが円内部の点Qを通り、円にぶつかる点。Pからの単位ベクトルと長さを返す。
//
var crosscircle = function(px, py, qx, qy){
	var ux = qx - px;
	var uy = qy - py;
	var ulen = ux*ux + uy*uy;
	if (ulen > 0.1){
		ulen = Math.sqrt(ulen);
		ux /= ulen;
		uy /= ulen;
		var ox = m_cx - px;
		var oy = m_cy - py;
		var inn = ox*ux + oy*uy;
		var len = ox*ox + oy*oy;
		if (len > 0.1){
			len = Math.sqrt(len);
			ulen = 2 * (m_r + 6) * Math.abs(inn / len);
		}else{
			ulen = 0;
		}
	}
	return {"ux" : ux, "uy" : uy, "ulen" : ulen};
};

// 結果・壁の厚さ計算
//
var reportimage = function(width, height, imgd){
	var cx = width / 2;
	var cy = height / 2;
	var px = [], py = [];
	var testcase = new Array(0,1,-1,2,-2,3,-3,4,-4,5,-5);
	var i;

	for (i=0; i<testcase.length; i++){
		px = [];
		py = [];
		var m = 0;
		var j,k;
		var lm = [];

		for (k=width-2; k>0; k--){
			var x = k;
			var y = cy + testcase[i];
			var pos = ((y + 0.5 | 0) * width + (x + 0.5 | 0)) * 4;
			var rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
			var alpha = imgd[pos+3];
			if (alpha < 10){
				m = 0;
			}else{
				if (m > 0){
					px[7] = x;
					py[7] = y;
				}
				if (rgb < 600){
					if (m == 2){
						px[6] = x;
						py[6] = y;
						break;
					}
					m = 2;
				}else{
					m = 1;
				}
			}
		}
		for (j=1; j<k; j++){
			var x = j;
			var y = cy + testcase[i];
			var pos = ((y + 0.5 | 0) * width + (x + 0.5 | 0)) * 4;
			var rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
			var alpha = imgd[pos+3];
			if (alpha < 10){
				m = 0;
			}else{
				if (m > 0){
					px[0] = x;
					py[0] = y;
				}
				if (rgb < 600){
					if (m == 2){
						px[1] = x;
						py[1] = y;
						break;
					}
					m = 2;
				}else{
					m = 1;
				}
			}
		}
		lm.push(1);
		lm.push(1);
		for (; j<k+2; j++){
			var x = j;
			var y = cy + testcase[i];
			var pos = ((y + 0.5 | 0) * width + (x + 0.5 | 0)) * 4;
			var rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
			var alpha = imgd[pos+3];
			var lmn = lm.length;
			if (alpha < 10){
				m = 0; // ring
				if (lm[lmn-1] == 0 && lm[lmn-2] == 1 && lm[lmn-3] == 1){
					px[6] = x;
					py[6] = y;
					if (!px[5] && (lm[lmn-2] > 1 || lm[lmn-3] > 1)){
						px[5] = x;
						py[5] = y;
					}
				}
			}else{
				if (rgb < 600){
					if (rgb < 60){
						m = 1; // outer
						if (lm[lmn-1] == 1 && lm[lmn-2] > 1 && lm[lmn-3] > 1){
							px[5] = x;
							py[5] = y;
							if (!px[4] && (lm[lmn-2] > 2 || lm[lmn-3] > 2)){
								px[4] = x;
								py[4] = y;
							}
						}
					}else{
						m = 2; // media
						if (lm[lmn-1] == 2 &&
						 ((lm[lmn-2] == 3 && lm[lmn-3] == 3) || (lm[lmn-3] == 3 && lm[lmn-4] == 3))){
							px[4] = x;
							py[4] = y;
						}else if (!px[2] && lm[lmn-1] == 2 &&
						 ((lm[lmn-2] == 1 && lm[lmn-3] == 1) || (lm[lmn-3] == 1 && lm[lmn-4] == 1))){
							px[2] = x;
							py[2] = y;
						}
					}
				}else{
					m = 3; // inner
					if (!px[3] && lm[lmn-1] == 3 &&
						((lm[lmn-2] < 3 && lm[lmn-3] < 3) ||(lm[lmn-3] < 3 && lm[lmn-4] < 3))){
						px[3] = x;
						py[3] = y;
						if (!px[2] && (lm[lmn-2] == 1 || lm[lmn-3] == 1)){
							px[2] = x;
							py[2] = y;
						}
					}
				}
			}
			lm.push(m);
		}
		if (!px[5]){
			px[5] = px[6];
			py[5] = py[6];
		}
		if (!px[4]){
			px[4] = px[5];
			py[4] = py[5];
		}

		if (px[0] && px[1] && px[2] && px[3] && px[4] && px[5] && px[6] && px[7]){
			break;
		}
	}

	var olmax, mlmax, ilmax, irmax, mrmax, ormax;
	if (px[1] > 0) {
		olmax = px[1] -cx+m_r+6-40 +0.01;
	}
	if (px[2] > 0) {
		mlmax = px[2] -cx+m_r+6-40 +0.01;
	}
	if (px[3] > 0) {
		ilmax = px[3] -cx+m_r+6-40 +0.01;
	}
	if (px[4] > 0) {
		irmax = cx+m_r+6-40 -px[4] +0.01;
	}
	if (px[5] > 0) {
		mrmax = cx+m_r+6-40 -px[5] +0.01;
	}
	if (px[6] > 0) {
		ormax = cx+m_r+6-40 -px[6] +0.01;
	}

	return {"olmax": olmax, "mlmax": mlmax, "ilmax": ilmax, "irmax": irmax, "mrmax": mrmax, "ormax": ormax};
};

// 同心円分布座標列から平均中心算出
//
var getcenter = function (px, py){
	var n = px.length;
	if (n < 10){
		return false;
	}
	var work_x = [];
	var work_y = [];
	var i,j,k;

	for (i=0; i<n; i++){
		j = ((n / 4 | 0) + i) % n;
		k = ((n / 2 | 0) + i) % n;
		var a,b,c,d,e,f,cx,cy,hd;

		a = px[i] - px[j];
		b = py[i] - py[j];
		cx = (px[i] + px[j]) / 2;
		cy = (py[i] + py[j]) / 2;
		e = a * cx + b * cy;
		c = px[j] - px[k];
		d = py[j] - py[k];
		cx = (px[j] + px[k]) / 2;
		cy = (py[j] + py[k]) / 2;
		f = c * cx + d * cy;
		hd = a*d - b*c;
		cx = (d*e-b*f) / hd;
		cy = (a*f-c*e) / hd;
		if (cx && cy){
			work_x.push(cx);
			work_y.push(cy);
		}
	}

	var t_x = [];
	var t_y = [];
	n = work_x.length;
	for (i=0; i<n; i++){
		var mx=0, my=0;
		for (j=0; j<5; j++){
			mx += work_x[(i+j)%n];
			my += work_y[(i+j)%n];
		}
		mx /= 5;
		my /= 5;

		var maxl = 0;
		var maxj = 0;
		for (j=0; j<5; j++){
			var dx = mx - work_x[(i+j)%n];
			var dy = my - work_y[(i+j)%n];
			var len = dx*dx + dy*dy;
			if (maxl < len){
				maxl = len;
				maxj = j;
			}
		}
		mx = my = 0;
		for (j=0; j<5; j++){
			if (j != maxj){
				mx += work_x[(i+j)%n];
				my += work_y[(i+j)%n];
			}
		}
		mx /= (j-1);
		my /= (j-1);
		t_x.push(mx);
		t_y.push(my);
	}

	n = t_x.length;
	var mx=0, my=0;
	for (i=0; i<n; i++){
		mx += t_x[i];
		my += t_y[i];
	}
	mx /= n;
	my /= n;

	var r = 0;
	for (i=0; i<px.length; i++){
		var dx = mx - px[i];
		var dy = my - py[i];
		r += Math.sqrt(dx*dx + dy*dy);
	}
	r /= px.length;

	return {"x" : mx, "y" : my, "r" : r};
};

// 外円調査
//
var getring = function(width, height, imgd){
	var cx = width / 2;
	var cy = height / 2;
	var i,j,x,y,pos,rgb,alpha;
	var ex = [];
	var ey = [];

	for (i=0; i<360; i+=2){
		var m = 0;
		var lm = [];
		var cos = m_cos[i];
		var sin = m_sin[i];

		for (j=0; j<cx; j+=1){
			x = cx + j * cos;
			y = cy + j * sin;
			pos = ((y + 0.5 | 0) * width + (x + 0.5 | 0)) * 4;
			rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
			alpha = imgd[pos+3];
			if (alpha < 10){
				m = 0;
			}else if (rgb < 600){
				if (rgb < 60){
					m = 1; // outer
				}else{
					m = 2; // media
				}
			}else{
				m = 3; // inner
			}
			lm.push(m);
		}
		for (j=lm.length-1; j>=0; j--){
			if (lm[j] != 0 && lm[j-1] != 0 && lm[j-2] != 0){
				x = cx + (j-1) * cos;
				y = cy + (j-1) * sin;
				ex.push(x);
				ey.push(y);
				break;
			}
		}
	}

	return getcenter(ex, ey);
};

// 外膜調査
//
var getouter = function(width, height, imgd){
	var cx = width / 2;
	var cy = height / 2;
	var x,y;
	var omap = [];

	var work_x = [];
	var work_y = [];
	var color;
	var i,j,k;

loop_end:
	for (k=0; k<2; k++){
		for (i=0; i<m_r-20; i++){
			var pos = width * 4;
			if (k == 0){
				pos *= (m_cy+i);
			}else{
				pos *= (m_cy-i);
			}
			var lm = [];
			lm.push(0);
			lm.push(0);
			pos += 2*4;
			for (j=2; j<width-2; j++){
				var rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
				var alpha = imgd[pos+3];
				if (alpha < 10){
					lm.push(0);
				}else if (rgb < 600){
					if (lm[lm.length-1] == 1){
						x = j-1;
						if (k == 0){y = m_cy+i;}
						else{		y = m_cy-i;}
						break loop_end;
					}
					lm.push(1);
				}else{
					lm.push(0);
				}
				pos += 4;
			}
		}
	}

	if (!x){
		return {"x": work_x, "y": work_y, "color": "#808080"};
	}

	var rgbcnt = 0;
	var tr=0, tg=0 ,tb=0;
	var mmr = cx - 1;
	mmr *= mmr;
	for (i=0, pos=0; i<height; i++){
		var lr=0,lg=0,lb=0;
		for (j=0; j<width; j++){
			var dy = i - cy;
			var dx = j - cx;
			var len = dx*dx + dy*dy;
			if (len > mmr){
				omap.push(0);
				lr = lg = lb = 0;
			}else{
				var r = imgd[pos];
				var g = imgd[pos+1];
				var b = imgd[pos+2];
				var alpha = imgd[pos+3];
				var rgb = r+g+b;
				if (alpha < 10){
					omap.push(0);
				}else if (rgb < 600){
					omap.push(1);
					if (rgb >= 60){
						if (Math.abs(lr-r) < 10 && Math.abs(lg-g) < 10 && Math.abs(lb-b) < 10){
							tr += r; tg += g; tb += b; rgbcnt++;
						}
					}
				}else{
					omap.push(0);
				}
				lr = r; lg = g; lb = b;
			}
			pos += 4;
		}
	}

	var roi;
	roi = makeroi(width, height, x, y, omap);
	var n = roi.x.length;
	if (n > 160){
		var m = (n / 160) | 0;
		for (i=0; i<n; i+=m){
			work_x.push(roi.x[i]);
			work_y.push(roi.y[i]);
		}
	}else{
		work_x = roi.x;
		work_y = roi.y;
	}

	if (rgbcnt > 0){
		tr = (tr / rgbcnt) | 0;
		tg = (tg / rgbcnt) | 0;
		tb = (tb / rgbcnt) | 0;
		color = "rgb(" + tr + "," + tg + "," + tb + ")";
	}
	return {"x": work_x, "y": work_y, "color": color};
};

// 調査MAP作成
//
var getimmap = function(width, height, imgd, cent){
	var i,j,x,y,pos,rgb,alpha;
	var cx = cent["x"];
	var cy = cent["y"];
	var cr = cent["r"];
	var ix, iy, mx, my;
	var imap = [];
	var mmap = [];
	var rlen = cr*cr;

loop_end:
	for (i=0; i<360; i++){
		var m = 0;
		var lm = [];
		var cos = m_cos[i];
		var sin = m_sin[i];
		for (j=0; j<cr; j+=1){
			x = cx + j * cos;
			y = cy + j * sin;
			pos = ((y + 0.5 | 0) * width + (x + 0.5 | 0)) * 4;
			rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
			alpha = imgd[pos+3];
			if (alpha < 10){
				m = 3;
			}else if (rgb < 600){
				if (rgb < 60){
					m = 1; // outer
				}else{
					m = 2; // media
				}
			}else{
				m = 3; // inner
			}
			lm.push(m);
		}
		for (j=0; j<cr-4; j+=1){
			if (lm[j] == 3 && lm[j+1] == 3 && lm[j+2] != 3 && lm[j+3] != 3){
				x = cx + (j+2) * cos;
				y = cy + (j+2) * sin;
				if (!ix){
					ix = x + 0.5 | 0;
					iy = y + 0.5 | 0;
					if (ix && mx){
						break loop_end;
					}
				}
			}
			if (lm[j] == 2 && lm[j+1] == 2 && lm[j+2] == 1 && lm[j+3] == 1){
				x = cx + (j+2) * cos;
				y = cy + (j+2) * sin;
				if (!mx){
					mx = x + 0.5 | 0;
					my = y + 0.5 | 0;
					if (ix && mx){
						break loop_end;
					}
				}
			}
		}
	}

	for (i=0; i<height; i++){
		for (j=0; j<width; j++){
			var dy = i - cy;
			var dx = j - cx;
			var len = dx*dx + dy*dy;
			if (len > rlen){
				imap.push(0);
				mmap.push(0);
			}else{
				pos = (i * width + j) * 4;
				rgb = imgd[pos] + imgd[pos+1] + imgd[pos+2];
				alpha = imgd[pos+3];
				if (alpha < 10){
					m = 3;
					imap.push(0);
					mmap.push(0);
				}else if (rgb < 600){
					if (rgb < 60){
						m = 1; // outer
						mmap.push(1);
						imap.push(1);
					}else{
						m = 2; // media
						imap.push(1);
						mmap.push(0);
					}
				}else{
					m = 3; // inner
					imap.push(0);
					mmap.push(0);
				}
			}
		}
	}
	return {"ix" : ix, "iy" : iy, "mx" : mx, "my" : my, "imap" : imap, "mmap" : mmap};
};

// ROI作成
//
var makeroi = function(width, height, ix, iy, imap){
	var roi_x = [];
	var roi_y = [];
	var i,j;

	if (!ix || !iy){
		return {"x" : roi_x, "y" : roi_y};
	}
	if (ix < 3 || width-3 < ix || iy < 3 || height-3 < iy){
		return {"x" : roi_x, "y" : roi_y};
	}

	var x=ix, y=iy, k=0;
	var pos;

	for (i=0; i<100; i++){
		pos = y * width + x;
		if (imap[pos] == 1){
			if (imap[pos-width] == 0 && imap[pos+1] == 1){
				roi_x.push(x);
				roi_y.push(y);
				ix=x; iy=y;
				k = 1;
				x += 1;
				break;
			}else if (imap[pos+1] == 0 && imap[pos+width] == 1){
				roi_x.push(x);
				roi_y.push(y);
				ix=x; iy=y;
				k = 2;
				y += 1;
				break;
			}else if (imap[pos+width] == 0 && imap[pos-1] == 1){
				roi_x.push(x);
				roi_y.push(y);
				ix=x; iy=y;
				k = 3;
				x -= 1;
				break;
			}else if (imap[pos-1] == 0 && imap[pos-width] == 1){
				roi_x.push(x);
				roi_y.push(y);
				ix=x; iy=y;
				k = 0;
				y -= 1;
				break;
			}
		}
		var d = (i / 8 | 0) + 1;
		var p = i % 8;
		if  (p == 0)    {x+=d;}
		else if (p == 1){x+=d;y+=d;}
		else if (p == 2){y+=d;}
		else if (p == 3){x-=d;y+=d;}
		else if (p == 4){x-=d;}
		else if (p == 5){x-=d;y-=d;}
		else if (p == 6){y-=d;}
		else            {x+=d;y-=d;}
	}

	var cnt=1;
	var dx=0, dy=0;
	do{
		dx += x;
		dy += y;
		pos = y * width + x;
		for (i=3; i<7; i++){
			j = (k+i) % 4;
			if (j==0 && imap[pos-width] == 1){
				k = 0;
				y -= 1;
				break;
			}else if (j==1 && imap[pos+1] == 1){
				k = 1;
				x += 1;
				break;
			}else if (j==2 && imap[pos+width] == 1){
				k = 2;
				y += 1;
				break;
			}else if (j==3 && imap[pos-1] == 1){
				k = 3;
				x -= 1;
				break;
			}
		}
		if ((cnt % 5) == 0){
			roi_x.push(dx / 5);
			roi_y.push(dy / 5);
			dx = 0;
			dy = 0;
		}
		cnt++;
	}while((x != ix || y != iy) && cnt < 3000);

	return {"x" : roi_x, "y" : roi_y};
};

// 図形解析
//
var analyzeimage = function(width, height, imgd){
	var i;
	var color = "#808080";
	var cent = getring(width, height, imgd);
	m_points_x[0] = m_points_x[1] = m_points_x[2] = [];
	m_points_y[0] = m_points_y[1] = m_points_y[2] = [];

	if (cent){
		var cr = cent["r"];
		var cx = cent["x"];
		var cy = cent["y"];

		m_ring_x = [];
		m_ring_y = [];
		for (i=0; i<=360; i+=3){
			m_ring_x[i] = (m_cx + cr * m_cos[i]);
			m_ring_y[i] = (m_cy + cr * m_sin[i]);
		}

		var outer = getouter(width, height, imgd);
		m_points_x[0] = outer["x"];
		m_points_y[0] = outer["y"];
		color = outer["color"];

		var immap = getimmap(width, height, imgd, cent);
		var imap = immap["imap"];
		var mmap = immap["mmap"];
		var ix = immap["ix"];
		var iy = immap["iy"];
		var mx = immap["mx"];
		var my = immap["my"];

		var roi;
		roi = makeroi(width, height, ix, iy, imap);
		m_points_x[2] = roi.x;
		m_points_y[2] = roi.y;
		roi = makeroi(width, height, mx, my, mmap);
		m_points_x[1] = roi.x;
		m_points_y[1] = roi.y;

//		var mul = (m_r+5.5) / cr;
		var mul = 0.995;
		for (i=0; i<m_points_x[0].length; i++){
			m_points_x[0][i] = (m_points_x[0][i] - cx) * mul + m_cx;
			m_points_y[0][i] = (m_points_y[0][i] - cy) * mul + m_cy;
		}

//		mul = (m_r+4.5) / cr;
		mul = 0.995;
		for (i=0; i<m_points_x[1].length; i++){
			m_points_x[1][i] = (m_points_x[1][i] - cx) * mul + m_cx;
			m_points_y[1][i] = (m_points_y[1][i] - cy) * mul + m_cy;
		}
		mul = 0.995;
		for (i=0; i<m_points_x[2].length; i++){
			m_points_x[2][i] = (m_points_x[2][i] - cx) * mul + m_cx;
			m_points_y[2][i] = (m_points_y[2][i] - cy) * mul + m_cy;
		}
	}
	return color;
};

///////////////////////////////////
// Public Scope
///////////////////////////////////
hsVacuumPaintPublic = {

init: function (canvas){
	var ctx = canvas.getContext('2d');
	var imgidx = 0;
	var mouseDown = false;
	var i;

	for (i=0; i<=360; i++){
		m_cos[i] = Math.cos(i * Math.PI / 180);
		m_sin[i] = Math.sin(i * Math.PI / 180);
	}

	if (window.navigator.userAgent.indexOf('iPhone')>0 ||
		window.navigator.userAgent.indexOf('iPod')>0 || 
		window.navigator.userAgent.indexOf('iPad')>0 ||
		window.navigator.userAgent.indexOf('Android')>0) {

		canvas.addEventListener('touchstart',
			function(e) {
				e.preventDefault();
				var n = e.touches.length;
				if (n > 0) {
					mouseDown = true;
					var rect=e.target.getBoundingClientRect();
					hsVacuumPaintPublic.mmove(e.touches[n-1].pageX-rect.left, e.touches[n-1].pageY-rect.top);
				}
			}, false);
		canvas.addEventListener('touchend',
			function(e) {
				mouseDown = false;
			}, false);
		canvas.addEventListener('touchmove',
			function (e) {
				e.preventDefault();
				if (mouseDown) {
					var rect=e.target.getBoundingClientRect();
					var n = e.touches.length;
					if (n > 0) {
					//for (i=0; i<e.touches.length; i++) {
						//mmove(e.touches[i].pageX-rect.left, e.touches[i].pageY-rect.top);
						hsVacuumPaintPublic.mmove(e.touches[n-1].pageX-rect.left, e.touches[n-1].pageY-rect.top);
					}
				}
			}, false
		);

	}else{
		canvas.addEventListener('mousedown',
			function(e) {
				e.preventDefault();
				mouseDown = true;
				var rect=e.target.getBoundingClientRect();
				hsVacuumPaintPublic.mmove(e.clientX-rect.left, e.clientY-rect.top);
			}, false);
		canvas.addEventListener('mouseup',
			function(e) {
				mouseDown = false;
			}, false);
		canvas.addEventListener('mousemove',
			function (e) {
				e.preventDefault();
				if (mouseDown) {
					var rect=e.target.getBoundingClientRect();
					hsVacuumPaintPublic.mmove(e.clientX-rect.left, e.clientY-rect.top);
				}
			}, false
		);
	}

	m_ctx = ctx;
	m_canvas_w = canvas.width;
	m_canvas_h = canvas.height;
	m_ctx.font = "16px 'MS Gothic'";
	this.initparam("#808080", true);
},

initparam: function (color, bPaint){
	var i;
	m_idx = 2;
	m_points_x[0] = [];
	m_points_y[0] = [];
	m_points_x[1] = [];
	m_points_y[1] = [];
	m_points_x[2] = [];
	m_points_y[2] = [];
	m_ring_x = [];
	m_ring_y = [];
	if (color){
		m_ncolor = color;
	}

	for (i=0; i<=360; i+=3){
		var cos = m_cos[i];
		var sin = m_sin[i];
		m_points_x[0].push(m_cx + (m_r-40+5.5)*cos);
		m_points_y[0].push(m_cy + (m_r-40+5.5)*sin);
		m_points_x[1].push(m_cx + (m_r-40-3.5)*cos);
		m_points_y[1].push(m_cy + (m_r-40-3.5)*sin);
		m_points_x[2].push(m_cx + (m_r-40-10.5)*cos);
		m_points_y[2].push(m_cy + (m_r-40-10.5)*sin);
		m_ring_x.push(m_cx + (m_r+6)*cos);
		m_ring_y.push(m_cy + (m_r+6)*sin);
	}
	if (bPaint){
		update(m_ctx, false);
	}
},

mmove: function (x, y){
	var r = (m_ring_x[0] - m_cx) - (3 * m_idx);
	calc(x, y, r, m_idx);
	update(m_ctx, false);
},

// intima/media/outer
choiceitem: function (no){
	m_idx = no;
	update(m_ctx, false);
},

// 画像入力
//
setimage: function(from){
	this.initparam(false, false);
	var cvs = document.createElement("canvas");
	cvs.width = 360;  // Fix layout
	cvs.height = 360; // Fix layout
	var ctx = cvs.getContext('2d');
	ctx.drawImage(from, 0, 0);
	var imgdata = ctx.getImageData(0,0, cvs.width, cvs.height);

	m_ncolor = analyzeimage(cvs.width, cvs.height, imgdata.data);
	update(m_ctx, false);
	return m_ncolor;
},

// 画像出力
//
saveimage: function(img, color){
	var cvs = document.createElement("canvas");
	cvs.width = 360;
	cvs.height = 360;
	var ctx = cvs.getContext('2d');
	update(ctx, color);
	img.src = cvs.toDataURL();
},

// コールバック受付  <img>と紐付け
//
imagecallback: function(no, img, callback){
	img.onload = function(){
		var imgdata = m_ctx.getImageData(0,0, 360, 360);
		var rep = reportimage(360, 360, imgdata.data);
		rep["mlen"] = m_points_x[1].length;
		rep["ilen"] = m_points_x[2].length;
		if (callback){
			callback(no, rep);
		}
	};
},

setcolor: function(color){
	m_ncolor = color;
	update(m_ctx, false);
}

} // Public Scope

}; // Constructor

